import React, {Component} from "react";
import { connect } from "react-redux";
import { addToDo, fetchToDos } from './actions';

class ToDo extends Component {
  
  constructor(props) {
    super(props);
    this.toDoInput = React.createRef();
  }

  componentDidMount() {
    this.props.fetchToDos('https://jsonplaceholder.typicode.com/todos?userId=1&completed=false');
  }

  handleSubmitToDo = (e) => {
    e.preventDefault();
    this.props.addToDo(this.toDoInput.current.value);
    e.target.reset();
  }

  render() {
    return (
      <div>
        <p>You have {this.props.toDos.length} ToDo items.</p>
        { this.props.loading &&
          <p>Loading...</p>
        }
        {
          this.props.error && 
          <p>Error fetching.</p>
        }
        <ul>
        {this.props.toDos.map((toDo, i) => <li key={i}>{toDo}</li>)}
        </ul>
        <form onSubmit={this.handleSubmitToDo}>
          <input 
            type="text"
            placeholder="enter ToDo item"
            ref={this.toDoInput}
          />
        </form>
      </div>
    )
  }
}

function mapStateToProps(state) {
  return {
    toDos: state.toDos,
    loading: state.loading,
    error: state.error
  };
}

const mapDispatchToProps = {
  addToDo,
  fetchToDos
}

export default connect(mapStateToProps, mapDispatchToProps)(ToDo);
