import { ADD_TODO, ADD_TODOS, ITEMS_LOADING, ITEMS_ERROR } from './actionTypes';
import axios from 'axios';

export const addToDo = (item) => ({
  type: ADD_TODO,
  item
});

export const addToDos = (items) => ({
  type: ADD_TODOS,
  toDos: items
});

export const itemsError = (bool) => ({
  type: ITEMS_ERROR,
  error: bool
});

export const itemsLoading = (bool) => ({
  type: ITEMS_LOADING,
  loading: bool
});

export const fetchToDos = (url) => {
  return (dispatch) => {
    dispatch(itemsLoading(true));
    axios.get(url)
    .then(function (response) {
      const items = response.data.map(dat => dat.title);
      dispatch(addToDos(items));
      dispatch(itemsLoading(false));
    })
    .catch(function (error) {
      dispatch(itemsError(true));
    });
  }
};