import { ADD_TODO, ADD_TODOS, ITEMS_LOADING, ITEMS_ERROR } from './actionTypes';

export default (state = {}, action) => {
  switch (action.type) {
    case ADD_TODO: 
      return ({
        ...state,
        toDos: [
          ...state.toDos,
          action.item
        ]
      });
    case ADD_TODOS:
      return ({
        ...state,
        toDos: [
          ...state.toDos,
          ...action.toDos
        ]
      });
    case ITEMS_LOADING:
      return ({
        ...state,
        loading: action.loading
      });
    case ITEMS_ERROR:
      return ({
        ...state,
        error: action.error
      });
    default:
      return state;
  }
}
